OpenTTD Source: IndustriesResolverObject Struct Reference

OpenTTD Source 14.0-beta3

Public Member Functions | Data Fields
IndustriesResolverObject Struct Reference

Resolver for industries. More...

`#include <newgrf_industries.h>`

Inheritance diagram for IndustriesResolverObject:

## Public Member Functions
| IndustriesResolverObject (TileIndex tile, Industry *indus, IndustryType type, uint32_t random_bits=0, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Constructor of the industries resolver. More...
TownScopeResolver * | GetTown ()
| Get or create the town scope object associated with the industry. More...
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, byte relative=0) override
| Get a resolver for the scope. More...
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for. More...
uint32_t | GetDebugID () const override
| Get an identifier for the item being resolved. More...
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Resolver constructor. More...
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup. More...
uint16_t | ResolveCallback ()
| Resolve callback. More...
virtual const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const
| Get the real sprites of the grf. More...
uint32_t | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32_t | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with. More...
void | ResetState ()
| Resets the dynamic state of the resolver object. More...

## Data Fields
IndustriesScopeResolver | industries_scope
| Scope resolver for the industry.
TownScopeResolver * | town_scope
| Scope resolver for the associated town (if needed and available, else `nullptr`).
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32_t | callback_param1
| First parameter (var 10) of the callback.
uint32_t | callback_param2
| Second parameter (var 18) of the callback.
uint32_t | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32_t | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32_t | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32_t | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Detailed Description

Resolver for industries.

Definition at line 42 of file newgrf_industries.h.

## Constructor & Destructor Documentation

## ◆ IndustriesResolverObject()

IndustriesResolverObject::IndustriesResolverObject | ( | TileIndex | tile,
|  | Industry * | indus,
|  | IndustryType | type,
|  | uint32_t | random_bits = `0`,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32_t | callback_param1 = `0`,
|  | uint32_t | callback_param2 = `0`
| ) |  |

Constructor of the industries resolver.

Parameters

  tile | Tile owned by the industry.
  indus | Industry being resolved.
  type | Type of the industry.
  random_bits | Random bits of the new industry.
  callback | Callback ID.
  callback_param1 | First parameter (var 10) of the callback.
  callback_param2 | Second parameter (var 18) of the callback.

Definition at line 467 of file newgrf_industries.cpp.

References GetIndustrySpec(), IndustrySpec::grf_prop, ResolverObject::root_spritegroup, and GRFFilePropsBase< Tcnt >::spritegroup.

## Member Function Documentation

## ◆ GetDebugID()

uint32_t IndustriesResolverObject::GetDebugID | ( |  | ) | const
| overridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 507 of file newgrf_industries.cpp.

References GetIndustrySpec(), IndustrySpec::grf_prop, industries_scope, GRFFilePropsBase< Tcnt >::local_id, and IndustriesScopeResolver::type.

## ◆ GetFeature()

GrfSpecFeature IndustriesResolverObject::GetFeature | ( |  | ) | const
| overridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 502 of file newgrf_industries.cpp.

## ◆ GetScope()

ScopeResolver* IndustriesResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | byte | relative = `0`
| ) |  |
| inlineoverridevirtual

Get a resolver for the scope.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 52 of file newgrf_industries.h.

References ResolverObject::GetScope(), GetTown(), industries_scope, VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

Referenced by NIHIndustry::Resolve().

## ◆ GetTown()

TownScopeResolver * IndustriesResolverObject::GetTown | ( |  | ) |

Get or create the town scope object associated with the industry.

Returns
  The associated town scope, if it exists.

Definition at line 485 of file newgrf_industries.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, industries_scope, IndustriesScopeResolver::industry, Industry::town, and town_scope.

Referenced by GetScope().

The documentation for this struct was generated from the following files:

- src/newgrf_industries.h
- src/newgrf_industries.cpp